#include <atari.h>
#include <peekpoke.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>


int main(void)
{
	int i;
	int input_fp, output_fp;
    unsigned char data1[8];
    unsigned char data2[8];
	off_t read_bytes;
	off_t offset = 8 + 16 * 4000;
	printf("\n\n\n\n\n\n");
    printf("Press RETURN to start tests\n");
    getchar();

	input_fp = open("INPUT.BIN", O_RDONLY);
    if (input_fp == -1)
    {
		printf("CANNOT OPEN INPUT.BIN\n\n");
		getchar();
		return 1;
    }
	printf("\nINPUT.BIN properly opened\n\n");
    
	printf("Moving to offset: %ld\n", offset);
	offset = lseek(input_fp, offset, SEEK_SET);
	if (offset == -1)
	{
		printf("SEEK NOT SUPPORTED\n\n");
		getchar();
		return 1;
	}
	printf("Seek performed properly\n");
	read_bytes = read(input_fp, &data1, 8);
	for (i = 0; i < 8; ++i)
	{
		printf("%02x ", data1[i]);
        if (data1[i] != i+8)
        {
            printf("WRONG DATA LOADED\n\n");
            getchar();
            return 1;
        }
	}   
	printf("\nCreating output file\n");
    output_fp = open("OUTPUT.BIN", O_RDWR | O_CREAT );
	printf("Writing to output file\n");
    write(output_fp, data1, 8);
    write(output_fp, data1, 8);
    write(output_fp, data1, 8);
	printf("Moving to offset in output file\n");
    offset = lseek(output_fp, 8, SEEK_SET);
	if (offset != 8)
	{
		printf("SEEK in output file not performed properly\n\n");
		getchar();
		return 1;
	}
	printf("Reading from output file\n");
	read_bytes = read(output_fp, &data2, 8);
    if (memcmp(data1, data2, 8) != 0)
    {
            printf("WRONG DATA LOADED FROM OUTPUT FILE\n\n");
            getchar();
            return 1;
    }
	printf("Correct data in output file!\n");
    printf("ALL TESTS PASSED PROPERLY\n\n");
    getchar();
    close(input_fp);
    close(output_fp);
	return 0;
}

